routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

// Route::get('/', function () {
//     return view('welcome');
// });

Route::redirect('/', '/home');

Route::resource('products', 'ProductsController');
Route::resource('categories', 'CategoriesController');
Route::resource('brands', 'BrandsController');
Route::resource('orders', 'OrdersController');
Route::get('chats/message/{to_user_id}', 'ChatsController@message')->name('chats.message');
Route::resource('chats', 'ChatsController');

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Category.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    public function user(){
        return $this->belongsTo('App\User');
    }

    public function products(){
        return $this->hasMany('App\Products');
    }
}

app/Http/Controllers/CategoriesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Category;
use App\User;

class CategoriesController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if (!auth()->user() == null && auth()->user()->role == 'seller') {
            $user_id = auth()->user()->id;
            $categories = Category::where('user_id', $user_id)->paginate(8);
            return view('categories.index')->with('categories', $categories);
        }
        return redirect()->route('products.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        if (!auth()->user() == null && auth()->user()->role == 'seller') {
            return view('categories.create');
        }
        return redirect()->route('products.index');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required'
        ]);

        $category = new Category();
        $category->user_id = auth()->user()->id;
        $category->name = $request->name;
        $category->save();

        return redirect()->route('categories.index')
            ->with('success', 'Category ' . $category->name . ' Successfully Added');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        return redirect()->route('products.index');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $category = Category::find($id);
        if (!auth()->user() == null && (auth()->user()->id == $category->user->id && auth()->user()->role == 'seller')) {
            return view('categories.edit')->with('category', $category);
        }
        return redirect()->route('categories.index');
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'name' => 'required'
        ]);

        $category = Category::find($id);
        $category->name = $request->name;
        $category->save();

        return redirect()->route('categories.index')
            ->with('success', 'Category ' . $category->name . ' has been Successfully Updated');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $category = Category::find($id);
        $category->delete();

        return redirect()->route('categories.index')
            ->with('error', 'Category ' . $category->name . ' has beend Removed');
    }
}

resources/views/categories/create.blade.php
@extends('layouts.app')

@section('content')
    <form method="POST" action="{{ route('categories.store') }}">
        <div class="card mx-auto" style="width: 30rem">
            <div class="card-header">
                Add Category
            </div>
            @include('categories.form')
        </div>
    </form>
@endsection

resources/views/categories/edit.blade.php
@extends('layouts.app')

@section('content')
    <form method="POST" action="{{ route('categories.update', $category->id) }}">
        <input type="hidden" name="_method" value="PUT">
        <div class="card mx-auto" style="width: 30rem">
            <div class="card-header">
                Update Category
            </div>
            @include('categories.form')
        </div>
    </form>
@endsection

resources/views/categories/form.blade.php
@csrf
<div class="card-body">
    <div class="form-group">
        <label for="name">Name</label>
        <input type="text" class="form-control" id="name" name="name" value="{{ $category->name ?? '' }}"
            placeholder="Category Name">
    </div>
    <a class="btn btn-primary" href="{{ route('categories.index') }}">Back</a>
    <input type="submit" value="Save" class="btn btn-success"
        onclick="this.disabled=true;this.value='Processing...';this.form.submit();">
</div>

resources/views/categories/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="card mx-auto" style="width: 35rem">
        <div class="card-header">
            Category List
        </div>
        <div class="card-body">
            <a href="{{ route('categories.create') }}" class="btn btn-primary"><b>+</b> Add Category</a><br><br>
            @if (count($categories) > 0)
                <table class="table table-bordered">
                    <thead>
                        <tr>
                            <th scope="col">Name</th>
                            <th scope="col">Action</th>
                        </tr>
                    </thead>
                    <tbody>
                        @foreach ($categories as $category)
                            <tr>
                                <td>{{ $category->name }}</td>
                                <form action="{{ route('categories.destroy', $category->id) }}" method="POST">
                                    @csrf
                                    {{-- <input type="hidden" name="_method" value="DELETE">
                                    --}}
                                    <td>
                                        <a class="btn btn-primary"
                                            href="{{ route('categories.edit', $category->id) }}">Update</a>
                                        {{-- <input type="submit" value="Delete"
                                            class="btn btn-danger"> --}}
                                    </td>
                                </form>
                            </tr>
                        @endforeach
                    </tbody>
                </table>
            @else
                <p>Category is Empty</p>
            @endif
            <div>{{ $categories->links() }}</div>
        </div>
    </div>
@endsection